
import oracle.jsp.runtime.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.servlet.jsp.*;
import oracle.jsp.el.*;
import javax.servlet.jsp.el.*;
import javax.management.MBeanServer;
import javax.management.ObjectName;
import com.tangosol.examples.jmx.JMXHelper;
import com.tangosol.net.CacheFactory;
import com.tangosol.net.NamedCache;
import java.util.List;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Set;
import java.util.Map;
import java.util.TreeMap;
import java.util.Iterator;
import com.tangosol.util.extractor.IdentityExtractor;
import com.tangosol.net.cache.WrapperNamedCache;
import com.tangosol.util.aggregator.LongSum;
import com.tangosol.util.Filter;
import com.tangosol.examples.trading.TradeLoader;


public class _rendernodesdata extends com.orionserver.http.OrionHttpJspPage {


  // ** Begin Declarations


private static Long[] getMemoryCapacity(JMXHelper helper, Set setNodes)
    {
    // get total cluster memory for storage enabled nodes
    Map mapMemMaxResult =
            helper.getAttributeAll(setNodes, "MemoryMaxMB");
    Map mapMemFreeResult =
            helper.getAttributeAll(setNodes, "MemoryAvailableMB");
    Long longMemoryMax = (Long) new WrapperNamedCache(mapMemMaxResult, null)
            .aggregate((Filter) null, new LongSum(IdentityExtractor.INSTANCE));
    Long longMemoryFree =
            (Long) new WrapperNamedCache(mapMemFreeResult, null)
                    .aggregate((Filter) null, new LongSum(IdentityExtractor.INSTANCE));

    return new Long[]{longMemoryMax, longMemoryFree};
    }

  // ** End Declarations

  public void _jspService(HttpServletRequest request, HttpServletResponse response) throws java.io.IOException, ServletException {

    response.setContentType( "text/html");
    /* set up the intrinsic variables using the pageContext goober:
    ** session = HttpSession
    ** application = ServletContext
    ** out = JspWriter
    ** page = this
    ** config = ServletConfig
    ** all session/app beans declared in globals.jsa
    */
    PageContext pageContext = JspFactory.getDefaultFactory().getPageContext( this, request, response, null, true, JspWriter.DEFAULT_BUFFER, true);
    // Note: this is not emitted if the session directive == false
    HttpSession session = pageContext.getSession();
    int __jsp_tag_starteval;
    ServletContext application = pageContext.getServletContext();
    JspWriter out = pageContext.getOut();
    _rendernodesdata page = this;
    ServletConfig config = pageContext.getServletConfig();
    javax.servlet.jsp.el.VariableResolver __ojsp_varRes = (VariableResolver)new OracleVariableResolverImpl(pageContext);

    try {


      out.write(__oracle_jsp_text[0]);
      out.write(__oracle_jsp_text[1]);
      
          String sCacheName = "demo";
          CacheFactory.ensureCluster();
          NamedCache cache = CacheFactory.getCache(sCacheName);
      
          // create JMXHelper
          JMXHelper helper = new JMXHelper();
      
          // find cluster MBean
          // null can bew replaced by domain name
          ObjectName cluster = helper.getClusterObjectName(null);
      
          // find all storage enabled nodes, by asking for the parents of
          // the StorageManagers
      
          // null can be replaced by cache
          Set setStorage = helper.getStorageManagerSet(null);
          Set setNodesStorage = helper.getParentNodeSet(setStorage);
      
          Long[] aLMem = getMemoryCapacity(helper, setNodesStorage);
          long lUsed = aLMem[0].longValue() - aLMem[1].longValue();
      
          int iCacheSize = cache.size();
          if (iCacheSize < 100000)
              {
              System.out.println("Trading...");
              new TradeLoader().loadTrades(100000);
              }
      
      out.write(__oracle_jsp_text[2]);
      out.print( setNodesStorage.size());
      out.write(__oracle_jsp_text[3]);
      out.print( aLMem[0]);
      out.write(__oracle_jsp_text[4]);
      out.print( cache.size());
      out.write(__oracle_jsp_text[5]);
      
          try
              {
              String      sName      = "demo";
              MBeanServer server     = helper.getServer();
              Set         setCache   = helper.getCacheSet(null, sName, Boolean.TRUE);
              List        listCache  = new ArrayList(setCache);
      
              Collections.sort(listCache,
                          new JMXHelper.ObjectNameComparator("nodeId")); //nodeId
      
              // the map of machine data keyed by machinename and value is a list of node data
              Map mapMachines = new TreeMap();
              for (int i = 0; i < listCache.size(); i++)
                  {
                  ObjectName objCache = (ObjectName) listCache.get(i);
                  ObjectName objNode = helper.getParentNode(objCache);
      
                  String sMachineName = (String) server.getAttribute(objNode, "MachineName");
      
                  // list of nodes for this particular machine
                  List listNodes = (List) mapMachines.get(sMachineName);
                  if (listNodes == null)
                      {
                      listNodes = new ArrayList();
                      }
      
                  Integer IId       = (Integer) server.getAttribute(objNode, "Id");
      
                  Integer INodeSize = (Integer) server.getAttribute(objCache, "Size");
                  float fNodeSize = INodeSize.floatValue();
      
                  //calculate percentage owned
                  float fCacheSize = (new Integer(iCacheSize)).floatValue();
                  float fPercent = (fNodeSize / fCacheSize) * 100;
                  float fRounded = Math.round(fPercent * 100) / 100f;
      
                  // list[IId, INodeSize, fRounded]
                  List listNodeData = new ArrayList();
                  listNodeData.add(0, IId);
                  listNodeData.add(1, INodeSize);
                  listNodeData.add(2, new Float(fRounded));
      
                  listNodes.add(listNodeData);
                  mapMachines.put(sMachineName, listNodes);
                  }
          
      out.write(__oracle_jsp_text[6]);
      
              Set setMachines = mapMachines.entrySet();
              for (Iterator iter = setMachines.iterator();
                   iter.hasNext();)
                  {
                  Map.Entry entry           = (Map.Entry) iter.next();
                  String    sCurrentMachine = (String) entry.getKey();
          
      out.write(__oracle_jsp_text[7]);
      out.print(sCurrentMachine);
      out.write(__oracle_jsp_text[8]);
      
              List listCurrentNodes = (List) entry.getValue();
              for (int i = 0; i < listCurrentNodes.size(); i++)
                  {
                  List listCurrentNode = (List) listCurrentNodes.get(i);
      
                  Float FCurrentPercent = (Float) listCurrentNode.get(2);
          
      out.write(__oracle_jsp_text[9]);
      out.print( i);
      out.write(__oracle_jsp_text[10]);
      out.print( listCurrentNode.get(1));
      out.write(__oracle_jsp_text[11]);
      out.print(FCurrentPercent);
      out.write(__oracle_jsp_text[12]);
      out.print(FCurrentPercent);
      out.write(__oracle_jsp_text[13]);
      out.print( 100 - FCurrentPercent);
      out.write(__oracle_jsp_text[14]);
      out.print( 100 - FCurrentPercent);
      out.write(__oracle_jsp_text[15]);
      out.print( FCurrentPercent);
      out.write(__oracle_jsp_text[16]);
      
                      }
                  }
              
      out.write(__oracle_jsp_text[17]);
      
                  }
              catch (Exception e) {}
              
      out.write(__oracle_jsp_text[18]);

    }
    catch (Throwable e) {
      if (!(e instanceof javax.servlet.jsp.SkipPageException)){
        try {
          if (out != null) out.clear();
        }
        catch (Exception clearException) {
        }
        pageContext.handlePageException(e);
      }
    }
    finally {
      OracleJspRuntime.extraHandlePCFinally(pageContext, true);
      JspFactory.getDefaultFactory().releasePageContext(pageContext);
    }

  }
  private static final char __oracle_jsp_text[][]=new char[19][];
  static {
    try {
    __oracle_jsp_text[0] = 
    "\n\n".toCharArray();
    __oracle_jsp_text[1] = 
    "\n".toCharArray();
    __oracle_jsp_text[2] = 
    "\n<table class=\"double\">\n    <tr>\n        <td>\n    <table border=\"0\">\n        <thead>\n            <th class=\"header\" colspan=\"2\">Coherence Data Grid Overview:</th>\n        </thead>\n        <tr>\n            <td class=\"header\">Storage Nodes:</td>\n            <td class=\"content\">\n                <font class=\"boldred\">".toCharArray();
    __oracle_jsp_text[3] = 
    "</font>\n            </td>\n        </tr>\n        <tr>\n            <td class=\"header\">Cluster Memory (MB):</td>\n            <td class=\"content\">\n                <font class=\"boldred\">".toCharArray();
    __oracle_jsp_text[4] = 
    "</font>\n            </td>\n        </tr>\n        <tr>\n            <td class=\"header\">Data Grid Objects:</td>\n            <td class=\"content\">\n                <font class=\"boldred\">".toCharArray();
    __oracle_jsp_text[5] = 
    "</font>\n            </td>\n        </tr>\n    </table>\n        </td>\n    </tr>\n\n    <tr>\n        <td>\n    ".toCharArray();
    __oracle_jsp_text[6] = 
    "\n\n    <table border=\"0\">\n        <thead>\n            <th class=\"header\" colspan=\"7\" align=\"left\">\n                Coherence Data Grid Distribution:\n            </th>\n        </thead>\n        <tr>\n            <td><font color=\"white\">Machine</font></td>\n            <td class=\"header\">Node</td>\n            <td class=\"header\">Objects Owned</td>\n            <td class=\"header\" width=\"160\">Data Ownership Percentage</td>\n        </tr>\n\n    ".toCharArray();
    __oracle_jsp_text[7] = 
    "\n        <tr>\n            <td class=\"header\" colspan=\"4\">\n                ".toCharArray();
    __oracle_jsp_text[8] = 
    "\n            </td>\n        </tr>\n    ".toCharArray();
    __oracle_jsp_text[9] = 
    "\n        <tr>\n            <td>&nbsp;</td>\n            <td class=\"content\">".toCharArray();
    __oracle_jsp_text[10] = 
    "</td>\n            <td class=\"content\">".toCharArray();
    __oracle_jsp_text[11] = 
    "</td>\n            <td class=\"content\">\n                <table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n                    <tr>\n                        <td>\n                            <table border=\"0\" cellpadding=\"0\" cellspacing=\"0\"\n                                   width=\"100\">\n                                <tbody><tr><td bgcolor=\"#C70A26\"\n                                               width=\"".toCharArray();
    __oracle_jsp_text[12] = 
    "%\">\n                                    <a title=\"Local Data\">\n                                        <img src=\"images/spacer.gif\"\n                                             title=\"Local Data(".toCharArray();
    __oracle_jsp_text[13] = 
    "%)\"\n                                             border=\"0\" height=\"15\"\n                                             width=\"100%\">\n                                    </a>\n                                </td>\n\n                                    <td bgcolor=\"#7F7F7F\"\n                                        width=\"".toCharArray();
    __oracle_jsp_text[14] = 
    "%\">\n\n                                        <a title=\"Cluster Data\">\n                                            <img src=\"images/spacer.gif\"\n                                                 title=\"Cluster Data (".toCharArray();
    __oracle_jsp_text[15] = 
    "%)\"\n                                                 border=\"0\" height=\"15\"\n                                                 width=\"100%\">\n                                        </a>\n                                    </td>\n                                </tr>\n                                </tbody>\n                            </table>\n                        </td>\n                        <td><font class=\"boldred\">&nbsp;&nbsp;".toCharArray();
    __oracle_jsp_text[16] = 
    "\n                            %</font></td>\n                    </tr>\n                </table>\n            </td>\n        </tr>\n\n\n        ".toCharArray();
    __oracle_jsp_text[17] = 
    "\n\n        ".toCharArray();
    __oracle_jsp_text[18] = 
    "\n\n    </table>\n\n        </td>\n    </tr>\n    <tr>\n        <td>\n            <form action=\"form.jsp\" method=\"get\">\n                <table border=\"0\">\n                    <thead>\n                        <th class=\"header\" colspan=\"5\" align=\"left\">Trade\n                            Execution:</th>\n                    </thead>\n                    <tr class=\"content\">\n                        <td><font class=\"boldred\">Symbol:</font></td>\n                        <td><input type=\"text\" name=\"symbol\" size=\"5\"></td>\n                        <td><font class=\"boldred\">Quantity:</font></td>\n                        <td><input type=\"text\" name=\"id\" size=\"5\"></td>\n                        <td><input type=\"submit\" value=\"Execute\"></td>\n                    </tr>\n                </table>\n            </form>\n        </td>\n    </tr>\n\n</table>\n".toCharArray();
    }
    catch (Throwable th) {
      System.err.println(th);
    }
}
}
