<html>
<%@ page import="javax.management.ObjectName,
                 com.tangosol.net.CacheFactory,
                 com.tangosol.net.NamedCache,
                 java.util.Set,
                 com.tangosol.examples.jmx.JMXHelper,
                 java.util.Map,
                 com.tangosol.net.cache.WrapperNamedCache,
                 com.tangosol.util.Filter,
                 com.tangosol.util.aggregator.LongSum,
                 com.tangosol.util.extractor.IdentityExtractor"%>

<%!
private static Long[] getMemoryCapacity(JMXHelper helper, Set setNodes)
    {
    // get total cluster memory for storage enabled nodes
    Map mapMemMaxResult =
            helper.getAttributeAll(setNodes, "MemoryMaxMB");
    Map mapMemFreeResult =
            helper.getAttributeAll(setNodes, "MemoryAvailableMB");
    Long longMemoryMax = (Long) new WrapperNamedCache(mapMemMaxResult, null)
            .aggregate((Filter) null,
                    new LongSum(IdentityExtractor.INSTANCE));
    Long longMemoryFree =
            (Long) new WrapperNamedCache(mapMemFreeResult, null)
                    .aggregate((Filter) null,
                            new LongSum(IdentityExtractor.INSTANCE));

    return new Long[]{longMemoryMax, longMemoryFree};
    }
%>


<head>
    <link href="layout.css" rel="stylesheet" type="text/css">
    <script type="text/javascript" src="js/prototype.js"></script>
</head>

<body>
<center>
    <%
        String sCacheName = "demo";
        CacheFactory.ensureCluster();

        // create JMXHelper
        JMXHelper helper = new JMXHelper();

        // find cluster MBean
        // null can bew replaced by domain name
        ObjectName cluster = helper.getClusterObjectName(null);

        // find all storage enabled nodes, by asking for the parents of
        // the StorageManagers

        // null can be replaced by cache
        Set setStorage = helper.getStorageManagerSet(null);
        Set setNodesStorage = helper.getParentNodeSet(setStorage);

        Long[] aLMem = getMemoryCapacity(helper, setNodesStorage);
        long lUsed = aLMem[0].longValue() - aLMem[1].longValue();
    %>

    <table class="double">
        <thead>
            <th class="header" colspan="2">Coherence Data Grid Overview:</th>
        </thead>
        <tr>
            <td class="header">Storage Nodes:</td>
            <td class="content">
                <font class="boldred"><%= setNodesStorage.size()%></font>
            </td>
        </tr>
        <tr>
            <td class="header">Cluster Memory (MB):</td>
            <td class="content">
                <font class="boldred"><%= aLMem[0]%></font>
            </td>
        </tr>
        <%
            NamedCache cache = CacheFactory.getCache(sCacheName);
        %>

        <tr>
            <td class="header">Data Grid Objects:</td>
            <td class="content">
                <font class="boldred"><%= cache.size()%></font>
            </td>
        </tr>
    </table>
</center>

</body>
</html>