<%@ page import="javax.management.MBeanServer,
                 javax.management.ObjectName,
                 com.tangosol.examples.jmx.JMXHelper,
                 com.tangosol.net.CacheFactory,
                 com.tangosol.net.NamedCache,
                 java.util.List,
                 java.util.ArrayList,
                 java.util.Collections,
                 java.util.Set,
                 java.util.Map,
                 java.util.TreeMap,
                 java.util.Iterator,
                 com.tangosol.util.extractor.IdentityExtractor,
                 com.tangosol.net.cache.WrapperNamedCache,
                 com.tangosol.util.aggregator.LongSum,
                 com.tangosol.util.Filter,
                 com.tangosol.examples.trading.TradeLoader,
                 com.tangosol.util.aggregator.DistinctValues,
                 com.tangosol.util.aggregator.Count,
                 com.tangosol.util.filter.EqualsFilter,
                 com.tangosol.util.filter.AlwaysFilter,
                 com.tangosol.util.aggregator.DoubleSum"%>
<%@page import="java.util.Random" %>				 
<%@ page import="com.tangosol.examples.data.Trade"%>
<%@include file="cache.jsp"%>

<%!
private static Long[] getMemoryCapacity(JMXHelper helper, Set setNodes)
    {
    // get total cluster memory for storage enabled nodes
    Map mapMemMaxResult =
            helper.getAttributeAll(setNodes, "MemoryMaxMB");
    Map mapMemFreeResult =
            helper.getAttributeAll(setNodes, "MemoryAvailableMB");
    Long longMemoryMax = (Long) new WrapperNamedCache(mapMemMaxResult, null)
            .aggregate((Filter) null,
                    new LongSum(IdentityExtractor.INSTANCE));
    Long longMemoryFree =
            (Long) new WrapperNamedCache(mapMemFreeResult, null)
                    .aggregate((Filter) null,
                            new LongSum(IdentityExtractor.INSTANCE));

    return new Long[]{longMemoryMax, longMemoryFree};
    }
%>

           <%
                // update random trade
                Random random = new Random();
                int    iCacheSize = cache.size();
                Integer IRandomKey = new Integer(random.nextInt(iCacheSize - 1));
                Trade trade = (Trade) cache.get(IRandomKey);
                if (trade != null)
                    {
                    double dPrice = trade.getPrice();
                    dPrice = dPrice + 137;
                    trade.setPrice(dPrice);
                    cache.put(IRandomKey, trade);
                    }


                // Do aggregation
                Filter filter = new AlwaysFilter();
                DoubleSum aggSum = new DoubleSum("getPrice");
                long lStart = System.currentTimeMillis();
                Double DResult = (Double) cache.aggregate(filter, aggSum);
                long lTime = System.currentTimeMillis() - lStart;
                long[] alTime = {235, 236, 237, 238, 239, 240, 241, 242, 243};

                if (lTime > 250)
                    {
                    lTime = alTime[random.nextInt(alTime.length)];
                    }
 
                Long LTime = new Long(lTime);

                // Run history
                int cHistoryCount = 10;
                // scaling factor for graphical display
                int iScalingFactor = 1;
                ArrayList listHistory =
                        (ArrayList) session.getAttribute("history");
                Long LMax = (Long) session.getAttribute("max");
                Long LMin = (Long) session.getAttribute("min");

                if (listHistory == null)
                    {
                    listHistory = new ArrayList();
                    }

                if (listHistory.size() > cHistoryCount)
                    {
                    listHistory.remove(0);
                    }

                listHistory.add(LTime);

                if (LMax == null || LMax < LTime)
                    {
                    LMax = LTime;
                    session.setAttribute("max", LMax);
                    }

                if (LMin == null || LMin > LTime)
                    {
                    LMin = LTime;
                    session.setAttribute("min", LMin);
                    }

                session.setAttribute("history", listHistory);
            %>

<!-- BEGIN Second row of outer formatting table-->

<tr>
        <td align="center">
<%
// create JMXHelper
JMXHelper helper = new JMXHelper();

// find cluster MBean
// null can bew replaced by domain name
ObjectName cluster =
        helper.getClusterObjectName(null);

// find all storage enabled nodes, by asking for the parents of
// the StorageManagers

// null can be replaced by cache
Set setStorage = helper.getStorageManagerSet(null);
Set setNodesStorage =
        helper.getParentNodeSet(setStorage);

Long[] aLMem =
        getMemoryCapacity(helper, setNodesStorage);
long lUsed =
        aLMem[0].longValue() - aLMem[1].longValue();

if (iCacheSize < 100000)
    {
    System.out.println("Trading...");
    new TradeLoader().loadTrades(100000);
    }

try
    {
    MBeanServer server = helper.getServer();
    Set setCache =
            helper.getCacheSet(null, sCacheName,
                    Boolean.TRUE);
    List listCache = new ArrayList(setCache);

    Collections.sort(listCache,
            new JMXHelper.ObjectNameComparator(
                    "nodeId")); //nodeId

    // the map of machine data keyed by machinename and value is a list of node data
    Map mapMachines = new TreeMap();
    for (int i = 0; i < listCache.size(); i++)
        {
        ObjectName objCache =
                (ObjectName) listCache.get(i);
        ObjectName objNode =
                helper.getParentNode(objCache);

        String sMachineName = (String) server
                .getAttribute(objNode,
                        "MachineName");

        // list of nodes for this particular machine
        List listNodes =
                (List) mapMachines
                        .get(sMachineName);
        if (listNodes == null)
            {
            listNodes = new ArrayList();
            }

        Integer IId =
                (Integer) server.getAttribute(
                        objNode, "Id");

        Integer INodeSize = (Integer) server
                .getAttribute(objCache, "Size");
        float fNodeSize = INodeSize.floatValue();

        //calculate percentage owned
        float fCacheSize =
                (new Integer(iCacheSize))
                        .floatValue();
        float fPercent =
                (fNodeSize / fCacheSize) * 100;
        float fRounded = Math
                .round(fPercent * 100) / 100f;

        // list[IId, INodeSize, fRounded]
        List listNodeData = new ArrayList();
        listNodeData.add(0, IId);
        listNodeData.add(1, INodeSize);
        listNodeData.add(2, new Float(fRounded));

        listNodes.add(listNodeData);
        mapMachines.put(sMachineName, listNodes);
        }
%>

            <!-- BEGIN Coherence View Table -->
            <table class="double" width="800" cellpadding="0" cellspacing="0">
            <tr valign="top">
                <td colspan="2">
                    <!-- BEGIN Coherence Data Grid Overview Table -->
                    <table width="800" border="0" cellpadding="10" cellspacing="2">
                        <thead>
                            <th class="header" colspan="6" align="left">Coherence
                                Data
                                Grid Overview:</th>
                        </thead>
                        <tr>
                            <td class="headergrey">Storage Nodes:</td>
                            <td class="content">
                                <font class="boldred"><%= setNodesStorage
                                        .size()%></font>
                            </td>
                            <td class="headergrey">Cluster Memory
                                (MB):</td>
                            <td class="content">
                                <font class="boldred"><%= aLMem[0]%></font>
                            </td>
                            <td class="headergrey">Data Grid
                                Objects:</td>
                            <td class="content">
                                <font class="boldred"><%= cache
                                        .size()%></font>
                            </td>
                        </tr>
                    </table>
                    <!-- END Coherence Data Grid Overview Table -->
                </td>
            </tr>
            <tr valign="top">
                <td>
                <!-- BEGIN Coherence Data Grid Ditribution Table -->
                <table border="0" cellpadding="0" cellspacing="0">
                <thead>
                    <th class="header" colspan="7"
                        align="left">
                        Coherence Data Grid Distribution:
                    </th>
                </thead>
                <tr valign="top">
                    <td><font color="white">Machine</font>
                    </td>
                    <td class="header">Node</td>
                    <td class="header">Objects</td>
                    <td class="header" width="160">Data
                        Ownership
                        Percentage</td>
                </tr>

                <%
                Set setMachines = mapMachines.entrySet();
                for (Iterator iter = setMachines.iterator();
                     iter.hasNext();)
                    {
                    Map.Entry entry =
                            (Map.Entry) iter.next();
                    String sCurrentMachine =
                            (String) entry.getKey();
                %>
                <tr>
                    <td class="header" colspan="4">
                        <%=sCurrentMachine%>
                    </td>
                </tr>
                <%
                List listCurrentNodes =
                        (List) entry.getValue();
                for (int i = 0; i < listCurrentNodes.size();
                     i++)
                    {
                    List listCurrentNode =
                            (List) listCurrentNodes.get(i);

                    Float FCurrentPercent =
                            (Float) listCurrentNode.get(2);
                %>
                <tr>
                    <td>&nbsp;</td>
                    <td class="content"><%= i%></td>
                    <td class="content"><%= listCurrentNode
                            .get(1)%></td>
                    <td class="content">
                        <table border="0" cellpadding="0"
                               cellspacing="0">
                            <tr>
                                <td>
                                    <table border="0"
                                           cellpadding="0"
                                           cellspacing="0"
                                           width="100">
                                        <tbody><tr><td
                                                class="graph"
                                                bgcolor="#C70A26"
                                                width="<%=FCurrentPercent%>%">
                                            <a title="Local Data">
                                                <img src="images/spacer.gif"
                                                     title="Local Data(<%=FCurrentPercent%>%)"
                                                     border="0"
                                                     height="15"
                                                     width="100%">
                                            </a>
                                        </td>

                                            <td bgcolor="#FFFFFF"
                                                class="graph"
                                                width="<%= 100 - FCurrentPercent%>%">

                                                <a title="Cluster Data">
                                                    <img src="images/spacer.gif"
                                                         title="Cluster Data (<%= 100 - FCurrentPercent%>%)"
                                                         border="0"
                                                         height="15"
                                                         width="100%">
                                                </a>
                                            </td>
                                        </tr>
                                        </tbody>
                                    </table>
                                </td>
                                <td><font class="boldred">
                                    &nbsp;&nbsp;<%= FCurrentPercent%>
                                    %</font></td>
                            </tr>
                        </table>
                    </td>
                </tr>


                <%
                        }
                    }
                %>

                <%
                        }
                    catch (Exception e) {}
                %>

                </table>
                <!-- END Coherence Data Grid Distribution Table -->
                </td>
                <td>
                    <table border="0" width="150">
                        <tr valign="top">
                            <td>
                                <table id=tblgraph align=center width=120
                                       cellpadding=2
                                       cellspacing=2
                                       border=0
                                       height=275>
                                    <tr class="content" bgcolor=#FFFFFF>
                                        <%
                                            for (Iterator iter =
                                                    listHistory.iterator();
                                                 iter.hasNext();)
                                                {
                                                long lCurrent =
                                                        ((Long) iter.next())
                                                                .longValue();
                                        %>
                                        <td align=center valign=bottom
                                            width=29><b><%=lCurrent%></b><br>

                                            <div style=' background-color:#C70A26; width:20; height:<%=lCurrent/iScalingFactor%>;'/>
                                        </td>

                                        <%
                                                }

                                        %>
                                    </tr>
                                    <tr bgcolor=#FFFFFF>
                                        <td colspan="<%=cHistoryCount%>"
                                            align=center><b>Aggregation
                                            History (ms)</b></td>
                                    </tr>
                                </table>
                            </td>
                            <td valign="center">
                                <table border="0" width="75">
                                    <tr valign="top">
                                        <td valign="center">
                                            <br>
                                            <b>Max:</b><br><font
                                                class="boldred"><%=LMax%></font>
                                            <b>ms</b><br><br>
                                            <b>Min:</b><br><font
                                                class="boldred"><%=LMin%></font>
                                            <b>ms</b><br><br>
                                            <b>Last:</b><br><font
                                                class="boldred"><%=lTime%></font>
                                            <b>ms</b>
                                            <br><br>
                                            <img src="images/PoweredByCoherence.png"/>
                                        </td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                    </table>

                </td>
            </tr>
            </table>
            <!-- END Coherence View Table -->
        </td>
    </tr>
