<html>
<%@ page import="javax.management.MBeanServer,
                 javax.management.ObjectName,
                 java.util.ArrayList,
                 java.util.List,
                 com.tangosol.net.CacheFactory,
                 com.tangosol.net.NamedCache,
                 java.util.Set,
                 com.tangosol.examples.jmx.JMXHelper,
                 java.util.Iterator,
                 java.util.Map,
                 com.tangosol.net.cache.WrapperNamedCache,
                 com.tangosol.util.Filter,
                 com.tangosol.util.aggregator.LongSum,
                 com.tangosol.util.extractor.IdentityExtractor,
                 java.util.HashSet"%>
<%@ page import="java.util.Collections"%>

<%!
private static Long[] getMemoryCapacity(JMXHelper helper, Set setNodes)
    {
    // get total cluster memory for storage enabled nodes
    Map mapMemMaxResult =
            helper.getAttributeAll(setNodes, "MemoryMaxMB");
    Map mapMemFreeResult =
            helper.getAttributeAll(setNodes, "MemoryAvailableMB");
    Long longMemoryMax = (Long) new WrapperNamedCache(mapMemMaxResult, null)
            .aggregate((Filter) null, new LongSum(IdentityExtractor.INSTANCE));
    Long longMemoryFree = (Long) new WrapperNamedCache(mapMemFreeResult, null)
            .aggregate((Filter) null, new LongSum(IdentityExtractor.INSTANCE));

    return new Long[]{longMemoryMax, longMemoryFree};
    }
%>


<head>
    <title>Tangosol Coherence Demo</title>
    <link href="layout.css" rel="stylesheet" type="text/css">
    <script type="text/javascript" src="js/prototype.js"></script>
</head>

    <body>
    <center>
        <table>
            <tr>
                <td class="banner">
                    <img src="images/tangosol_coherence_demo_banner.png"
                         alt="Tangosol Coherence Demo"/><br>
                </td>
            </tr>
        </table>
    <%
    String sName = "demo";
    CacheFactory.ensureCluster();

    // create JMXHelper
    JMXHelper helper = new JMXHelper();

    // find cluster MBean
    ObjectName cluster = helper.getClusterObjectName(null /*domain name*/);

    // find all node MBeans
    Set setNodes = helper.getNodeSet(cluster);
    Set setStorage = helper.getStorageManagerSet(null /*cache*/);

    // find all storage enabled nodes, by asking for the parents of
    // the StorageManagers
    Set setNodesStorage = helper.getParentNodeSet(setStorage);

    Set setNodesStorageDisabled = new HashSet(setNodes);
    setNodesStorageDisabled.removeAll(setNodesStorage);

    List listNodesStorageDisabled = new ArrayList(setNodesStorageDisabled);
    Collections.sort(listNodesStorageDisabled, new JMXHelper.ObjectNameComparator("nodeId"));

    Long[] aLMem = getMemoryCapacity(helper, setNodesStorage);
    long   lUsed = aLMem[0].longValue() - aLMem[1].longValue();
    %>

    <b>Cluster Information:</b><br>

    Nodes in the cluster: <%= setNodes.size()%><br>
    Memory: Total: <%= aLMem[0]%> Used: <%= lUsed%> Free: <%=aLMem[1]%><br>

    <br>
    <b>Node Information:</b>
    <br>
    <div align="center">
        <table>
            <tr>
                <td>
                    <div id="clients" align="left">
                        Loading...
                    </div>
                    <script type="text/javascript">
                        new Ajax.PeriodicalUpdater($('clients'),
                                "renderclients.jsp", {
                            frequency: 1,
                            onSuccess: function()
                                {
                                Element.setOpacity('updatesponsor', 0.0);
                                Effect.Appear('updatesponsor', { duration: 2.0 });
                                }
                        }
                                );
                    </script>
                </td>
                <td>
                    <div id="servers" align="right">
                        Loading...
                    </div>
                    <script type="text/javascript">
                        new Ajax.PeriodicalUpdater($('servers'),
                                "renderservers.jsp", {
                            frequency: 1,
                            onSuccess: function()
                                {
                                Element.setOpacity('updatesponsor', 0.0);
                                Effect.Appear('updatesponsor', { duration: 2.0 });
                                }
                        }
                                );
                    </script>
                </td>
            </tr>
            <tr>
                <td>
                    <div id="datadistribution" align="left">
                        Loading...
                    </div>
                    <script type="text/javascript">
                        new Ajax.PeriodicalUpdater($('datadistribution'),
                                "rendernodesdata.jsp", {
                            frequency: 1,
                            onSuccess: function()
                                {
                                Element.setOpacity('updatesponsor', 0.0);
                                Effect.Appear('updatesponsor', { duration: 2.0 });
                                }
                        }
                                );
                    </script>
                </td>
                <td>
                    <div id="distinct" align="left">
                        Loading...
                    </div>
                    <script type="text/javascript">
                        new Ajax.PeriodicalUpdater($('distinct'),
                                "distinct.jsp", {
                            frequency: 1,
                            onSuccess: function()
                                {
                                Element.setOpacity('updatesponsor', 0.0);
                                Effect.Appear('updatesponsor', { duration: 2.0 });
                                }
                        }
                                );
                    </script>
                </td>
            </tr>
        </table>

    </div>
    <br>
    <b>Data Distribution:</b>
    <br>

    <br>
    </center>

    </body>
</html>