<html>
<%@ page import="java.util.ArrayList,
                 com.tangosol.net.CacheFactory,
                 com.tangosol.net.NamedCache,
                 java.util.Set,
                 java.util.Iterator,
                 com.tangosol.util.Filter,
                 com.tangosol.util.aggregator.DistinctValues,
                 com.tangosol.util.aggregator.Count,
                 com.tangosol.util.filter.EqualsFilter,
                 com.tangosol.util.aggregator.DoubleSum,
                 com.tangosol.util.filter.AlwaysFilter"%>

<head>
    <title>Tangosol Coherence Demo</title>
    <link href="layout.css" rel="stylesheet" type="text/css">
    <script type="text/javascript" src="js/prototype.js"></script>
</head>

    <body>
    <center>
        <table class="double" width="500">
        <thead>
            <th class="header" colspan="7" align="left">
                Coherence Data Grid Aggregations:
            </th>
        </thead>

        <tr>
                <td>
                    <table width="40">
                        <thead>
                            <th class="header" colspan="2">
                                Distinct Trades by Symbol
                            </th>
                        </thead>
                        <tr>
                            <td class="header">Symbol</td>
                            <td class="header">Count</td>
                        </tr>

                        <%
                            String sName = "demo";
                            NamedCache cache = CacheFactory.getCache(sName);
                            Set setDistinct = (Set) cache.aggregate(
                                    (Filter) null,
                                    new DistinctValues("getSymbol"));
                            int iTotal = 0;
                            for (Iterator iter =
                                    setDistinct.iterator();
                                 iter.hasNext();)
                                {
                                String sSymbol = (String) iter.next();
                                int iCount = ((Integer) cache.aggregate(
                                        new EqualsFilter("getSymbol", sSymbol),
                                        new Count())).intValue();
                                iTotal += iCount;

                        %>
                        <tr>
                            <td class="content"><b><%=sSymbol%></b></td>
                            <td class="content"><b><%=iCount%></b></td>
                        </tr>
                        <%
                                }
                        %>
                        <tr>
                            <td class="header"><font class="boldred">TOTAL</font></td>
                            <td class="header"><font class="boldred"><%=iTotal%></font></td>
                        </tr>
                    </table>

                </td>
                <%
                    // Filter filter = new EqualsFilter("getSymbol", sAggSymbol);
                    Filter filter = new AlwaysFilter();
                    DoubleSum aggSum = new DoubleSum("getPrice");
                    long lStart = System.currentTimeMillis();
                    Double DResult = (Double) cache.aggregate(filter, aggSum);
                    long lTime = System.currentTimeMillis() - lStart;

                    if (lTime > 1000)
                        {
                        lTime = 997;
                        }

                    Long LTime = new Long(lTime);

                    // Run history
                    int       cHistoryCount = 10;
                    // scaling factor for graphical display
                    int       iScalingFactor = 3;
                    ArrayList listHistory = (ArrayList) session.getAttribute("history");
                    Long      LMax        = (Long) session.getAttribute("max");
                    Long      LMin        = (Long) session.getAttribute("min");

                    if (listHistory == null)
                        {
                        listHistory = new ArrayList();
                        }

                    if (listHistory.size() > cHistoryCount)
                        {
                        listHistory.remove(0);
                        }

                    listHistory.add(LTime);

                    if (LMax == null || LMax < LTime)
                        {
                        LMax = LTime;
                        session.setAttribute("max", LMax);
                        }

                    if (LMin == null || LMin > LTime)
                        {
                        LMin = LTime;
                        session.setAttribute("min", LMin);
                        }

                    session.setAttribute("history", listHistory);

                %>
                <td valign="bottom">
                    <table border="0" width="150">
                        <tr>
                            <td>
                                <table id=tblgraph align=center width=120
                                       cellpadding=2
                                       cellspacing=2
                                       border=0
                                        height=400>
                                    <tr class="content" bgcolor=#FFFFFF>
                                        <%
                                            for (Iterator iter =
                                                    listHistory.iterator();
                                                 iter.hasNext();)
                                                {
                                                long lCurrent =
                                                        ((Long) iter.next())
                                                                .longValue();
                                        %>
                                        <td align=center valign=bottom
                                            width=29><b><%=lCurrent%></b><br>

                                            <div style=' background-color:#C70A26; width:20; height:<%=lCurrent/iScalingFactor%>;'/>
                                        </td>

                                        <%
                                                }

                                        %>
                                    </tr>
                                    <tr bgcolor=#FFFFFF>
                                        <td colspan="<%=cHistoryCount%>"
                                            align=center><b>Aggregation History (ms)</b></td>
                                    </tr>
                                </table>
                            </td>
                            <td valign="center">
                                <table border="0" width="75">
                                    <tr valign="center">
                                        <td valign="center">
                                            <b>Max:</b><br><font class="boldred"><%=LMax%></font><b>ms</b><br><br>
                                            <b>Min:</b><br><font class="boldred"><%=LMin%></font><b>ms</b><br><br>
                                            <b>Last:</b><br><font class="boldred"><%=lTime%></font><b>ms</b><br><br>

                                        </td>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
            <tr>
            <td colspan="2" align="center">
                    <table>
                        <tr>
                            <td class="content">
                                Aggregated <font class="boldred">ALL <%=cache
                                    .size()%></font> trades in
                                <font class="boldred"><%=lTime%>ms</font>
                                with a result of
                                <font class="boldred">$<%=DResult%></font>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
            <tr>
                <td>
                </td>
            </tr>
        </table>
    </center>

    </body>
</html>