<%@ page import="javax.management.MBeanServer,
                 javax.management.ObjectName,
                 com.tangosol.examples.jmx.JMXHelper,
                 com.tangosol.net.CacheFactory,
                 com.tangosol.net.NamedCache,
                 java.util.List,
                 java.util.ArrayList,
                 java.util.Collections,
                 java.util.Set,
                 java.util.Map,
                 java.util.TreeMap,
                 java.util.Iterator,
                 com.tangosol.util.extractor.IdentityExtractor,
                 com.tangosol.net.cache.WrapperNamedCache,
                 com.tangosol.util.aggregator.LongSum,
                 com.tangosol.util.Filter,
                 com.tangosol.examples.trading.TradeLoader"%>

<%!
private static Long[] getMemoryCapacity(JMXHelper helper, Set setNodes)
    {
    // get total cluster memory for storage enabled nodes
    Map mapMemMaxResult =
            helper.getAttributeAll(setNodes, "MemoryMaxMB");
    Map mapMemFreeResult =
            helper.getAttributeAll(setNodes, "MemoryAvailableMB");
    Long longMemoryMax = (Long) new WrapperNamedCache(mapMemMaxResult, null)
            .aggregate((Filter) null, new LongSum(IdentityExtractor.INSTANCE));
    Long longMemoryFree =
            (Long) new WrapperNamedCache(mapMemFreeResult, null)
                    .aggregate((Filter) null, new LongSum(IdentityExtractor.INSTANCE));

    return new Long[]{longMemoryMax, longMemoryFree};
    }
%>
<%
    String sCacheName = "demo";
    CacheFactory.ensureCluster();
    NamedCache cache = CacheFactory.getCache(sCacheName);

    // create JMXHelper
    JMXHelper helper = new JMXHelper();

    // find cluster MBean
    // null can bew replaced by domain name
    ObjectName cluster = helper.getClusterObjectName(null);

    // find all storage enabled nodes, by asking for the parents of
    // the StorageManagers

    // null can be replaced by cache
    Set setStorage = helper.getStorageManagerSet(null);
    Set setNodesStorage = helper.getParentNodeSet(setStorage);

    Long[] aLMem = getMemoryCapacity(helper, setNodesStorage);
    long lUsed = aLMem[0].longValue() - aLMem[1].longValue();

    int iCacheSize = cache.size();
    if (iCacheSize < 100000)
        {
        System.out.println("Trading...");
        TradeLoader.loadTrades(100000);
        }
%>
<table class="double">
    <tr>
        <td>
    <table border="0">
        <thead>
            <th class="header" colspan="2">Coherence Data Grid Overview:</th>
        </thead>
        <tr>
            <td class="header">Storage Nodes:</td>
            <td class="content">
                <font class="boldred"><%= setNodesStorage.size()%></font>
            </td>
        </tr>
        <tr>
            <td class="header">Cluster Memory (MB):</td>
            <td class="content">
                <font class="boldred"><%= aLMem[0]%></font>
            </td>
        </tr>
        <tr>
            <td class="header">Data Grid Objects:</td>
            <td class="content">
                <font class="boldred"><%= cache.size()%></font>
            </td>
        </tr>
    </table>
        </td>
    </tr>

    <tr>
        <td>
    <%
    try
        {
        String      sName      = "demo";
        MBeanServer server     = helper.getServer();
        Set         setCache   = helper.getCacheSet(null, sName, Boolean.TRUE);
        List        listCache  = new ArrayList(setCache);

        Collections.sort(listCache,
                    new JMXHelper.ObjectNameComparator("nodeId")); //nodeId

        // the map of machine data keyed by machinename and value is a list of node data
        Map mapMachines = new TreeMap();
        for (int i = 0; i < listCache.size(); i++)
            {
            ObjectName objCache = (ObjectName) listCache.get(i);
            ObjectName objNode = helper.getParentNode(objCache);

            String sMachineName = (String) server.getAttribute(objNode, "MachineName");

            // list of nodes for this particular machine
            List listNodes = (List) mapMachines.get(sMachineName);
            if (listNodes == null)
                {
                listNodes = new ArrayList();
                }

            Integer IId       = (Integer) server.getAttribute(objNode, "Id");

            Integer INodeSize = (Integer) server.getAttribute(objCache, "Size");
            float fNodeSize = INodeSize.floatValue();

            //calculate percentage owned
            float fCacheSize = (new Integer(iCacheSize)).floatValue();
            float fPercent = (fNodeSize / fCacheSize) * 100;
            float fRounded = Math.round(fPercent * 100) / 100f;

            // list[IId, INodeSize, fRounded]
            List listNodeData = new ArrayList();
            listNodeData.add(0, IId);
            listNodeData.add(1, INodeSize);
            listNodeData.add(2, new Float(fRounded));

            listNodes.add(listNodeData);
            mapMachines.put(sMachineName, listNodes);
            }
    %>

    <table border="0">
        <thead>
            <th class="header" colspan="7" align="left">
                Coherence Data Grid Distribution:
            </th>
        </thead>
        <tr>
            <td><font color="white">Machine</font></td>
            <td class="header">Node</td>
            <td class="header">Objects Owned</td>
            <td class="header" width="160">Data Ownership Percentage</td>
        </tr>

    <%
        Set setMachines = mapMachines.entrySet();
        for (Iterator iter = setMachines.iterator();
             iter.hasNext();)
            {
            Map.Entry entry           = (Map.Entry) iter.next();
            String    sCurrentMachine = (String) entry.getKey();
    %>
        <tr>
            <td class="header" colspan="4">
                <%=sCurrentMachine%>
            </td>
        </tr>
    <%
        List listCurrentNodes = (List) entry.getValue();
        for (int i = 0; i < listCurrentNodes.size(); i++)
            {
            List listCurrentNode = (List) listCurrentNodes.get(i);

            Float FCurrentPercent = (Float) listCurrentNode.get(2);
    %>
        <tr>
            <td>&nbsp;</td>
            <td class="content"><%= i%></td>
            <td class="content"><%= listCurrentNode.get(1)%></td>
            <td class="content">
                <table border="0" cellpadding="0" cellspacing="0">
                    <tr>
                        <td>
                            <table border="0" cellpadding="0" cellspacing="0"
                                   width="100">
                                <tbody><tr><td bgcolor="#C70A26"
                                               width="<%=FCurrentPercent%>%">
                                    <a title="Local Data">
                                        <img src="images/spacer.gif"
                                             title="Local Data(<%=FCurrentPercent%>%)"
                                             border="0" height="15"
                                             width="100%">
                                    </a>
                                </td>

                                    <td bgcolor="#7F7F7F"
                                        width="<%= 100 - FCurrentPercent%>%">

                                        <a title="Cluster Data">
                                            <img src="images/spacer.gif"
                                                 title="Cluster Data (<%= 100 - FCurrentPercent%>%)"
                                                 border="0" height="15"
                                                 width="100%">
                                        </a>
                                    </td>
                                </tr>
                                </tbody>
                            </table>
                        </td>
                        <td><font class="boldred">&nbsp;&nbsp;<%= FCurrentPercent%>
                            %</font></td>
                    </tr>
                </table>
            </td>
        </tr>


        <%
                }
            }
        %>

        <%
            }
        catch (Exception e) {}
        %>

    </table>

        </td>
    </tr>
    <tr>
        <td>
            <form action="form.jsp" method="get">
                <table border="0">
                    <thead>
                        <th class="header" colspan="5" align="left">Trade
                            Execution:</th>
                    </thead>
                    <tr class="content">
                        <td><font class="boldred">Symbol:</font></td>
                        <td><input type="text" name="symbol" size="5"></td>
                        <td><font class="boldred">Quantity:</font></td>
                        <td><input type="text" name="id" size="5"></td>
                        <td><input type="submit" value="Execute"></td>
                    </tr>
                </table>
            </form>
        </td>
    </tr>

</table>
